package com.sumanta.communication;

import java.io.IOException;

import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.midlet.MIDlet;

import com.sumanta.common.CommonReadWrite;
import com.sumanta.common.CommonVariables;
import com.sumanta.midlet.BlueP2P;

public class BlueClient implements Runnable, DiscoveryListener{

	public UUID[] uuidSet;
	public RemoteDevice[] devices;
	public DiscoveryAgent agent;
	public String serviceUrl;
	private MIDlet parent;
	
	public BlueClient(MIDlet parent)
	{
		this.parent = parent;
		try {
			agent = LocalDevice.getLocalDevice().getDiscoveryAgent();
			
		} catch (BluetoothStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	public void run()
	{
		try {
			agent.startInquiry(DiscoveryAgent.GIAC, this);
		} catch (BluetoothStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void deviceDiscovered(RemoteDevice remote, DeviceClass devclass) {
		System.out.println("device discovered");
		System.out.println("Device major: "+devclass.getMajorDeviceClass()+ " and minor class: "+
				devclass.getMinorDeviceClass());
		try {
			System.out.println("bluetooth addr: "+remote.getBluetoothAddress()+" friendly name: "+remote.getFriendlyName(true));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//init service searching
		uuidSet = new UUID[1];
		uuidSet[0] = CommonVariables.MYUUID;
		try {
			int searchID = agent.searchServices(null, uuidSet, remote, this);
		} catch (BluetoothStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void inquiryCompleted(int arg0) {
		// TODO Auto-generated method stub
		
	}
	public void serviceSearchCompleted(int transID, int responseCode) {
		try {
			StreamConnection conn = (StreamConnection) Connector.open(serviceUrl);
			CommonVariables.mastersTurn = false;
			CommonVariables.conn = conn;
			((BlueP2P)parent).removeTicker();
			new Thread(){
				public void run()
				{
					while(true)
						CommonReadWrite.read(CommonVariables.conn);
				}
			};
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	public void servicesDiscovered(int arg0, ServiceRecord[] arg1) {
		System.out.println("service discovered");
		for(int i=0; i<arg1.length; i++)
			serviceUrl = arg1[i].getConnectionURL(0, false);
	}
}
