package com.sumanta.communication;

import java.io.IOException;

import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.LocalDevice;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;
import javax.microedition.midlet.MIDlet;

import com.sumanta.common.CommonReadWrite;
import com.sumanta.common.CommonVariables;
import com.sumanta.midlet.BlueP2P;

public class BlueServer implements Runnable {
	
	private StreamConnection conn;
	private StreamConnectionNotifier notifier;
	private LocalDevice device;
	private static String serverUrl = "btspp://localhost:" + CommonVariables.MYUUID +
		";name=rfcommtest;authorize=true";
	private MIDlet parent;
	
	public BlueServer(MIDlet parent)
	{
		this.parent = (BlueP2P)parent;
		try {
			/*
			 * get the instance of local device
			 */
			device = LocalDevice.getLocalDevice();
			device.setDiscoverable(DiscoveryAgent.GIAC);
			
			//starting the connection notifier
			notifier = (StreamConnectionNotifier) Connector.open(serverUrl);
			System.out.println("server about to start..");
		} catch (BluetoothStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void run() {
		/*
		 * In this class the service will be listening for incoming connections
		 */
		System.out.println("server is up");
		try {
			conn = notifier.acceptAndOpen();
			CommonVariables.conn = conn;
			((BlueP2P)parent).removeTicker();
			new Thread(){
				public void run()
				{
					while(true)
						CommonReadWrite.read(conn);
				}
			};
			//I have received connection, so I am the master ;)
			CommonVariables.mastersTurn = true;
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
