package com.sumanta.midlet;

import java.io.IOException;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.lcdui.Ticker;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.sumanta.common.CommonReadWrite;
import com.sumanta.common.CommonVariables;
import com.sumanta.communication.BlueClient;
import com.sumanta.communication.BlueServer;
import com.sun.midp.lcdui.Text;

public class BlueP2P extends MIDlet implements CommandListener {

	private Command exitCommand;
	private TextField msgbox;
	private Command sendCommnd;
	private Display display;
	Form form;
	private List menu;
	Ticker waitingTicker;
	public static TextField readfield;
	public static TextField turnField;
	
	public BlueP2P() {
		exitCommand = new Command("Exit", Command.EXIT, 0);
		sendCommnd = new Command("Send", Command.SCREEN, 1);
		msgbox = new TextField("Type message", "", 80, TextField.ANY);
		menu = new List("Mode of connection", List.EXCLUSIVE | List.IMPLICIT);
		menu.append("Wait for connection", null);
		menu.append("Connect to another device", null);
		menu.addCommand(exitCommand);
		readfield = new TextField("Messages got", "", 80, TextField.ANY);
		turnField = new TextField("Turn", "", 80, TextField.ANY);
		waitingTicker = new Ticker("Waiting for device to connect");
		display = Display.getDisplay(this);
		form = new Form("BlueP2P");
		form.setTicker(waitingTicker);
		form.addCommand(exitCommand);
		form.addCommand(sendCommnd);
		form.append(msgbox);
		form.append(readfield);
		form.append(turnField);
		form.setCommandListener(this);
		menu.setCommandListener(this);
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		//clean up
		try {
				if(CommonVariables.conn != null)
					CommonVariables.conn.close();
				if(CommonVariables.in != null)
					CommonVariables.in.close();
				if(CommonVariables.out != null)
					CommonVariables.out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
	}

	protected void pauseApp() {

	}

	protected void startApp() throws MIDletStateChangeException {
		/*
		 * show the menu so that user can choose whether he will be a master or client
		 */
		display.setCurrent(menu);
		
		/*
		 * todo - depending on which role you take, kill the other part
		 */
//		Thread t = new Thread(new BlueClient());
//		t.start();
//		t = new Thread(new BlueServer());
//		t.start();
//		
//		if(CommonVariables.mastersTurn)
//			//you are the server, so you should listen first
//			turnField.setString("Your friend's turn");
//		else
//			turnField.setString("Its your turn.");
	}

	public void commandAction(Command cmd, Displayable disp) {
		if(cmd == menu.SELECT_COMMAND)
		{
			int choice = menu.getSelectedIndex();
			System.out.println("In menu select and choice: "+ choice);
			if(choice == 0)new Thread(new BlueClient(this)).start();
			else if(choice == 1)new Thread(new BlueServer(this)).start();
			
			//set the screen to the chatting form
			display.setCurrent(form);
		}
		else if(cmd == exitCommand)
		{
			try {
				destroyApp(true);
				notifyDestroyed();
			} catch (MIDletStateChangeException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			notifyDestroyed();
		}
		else
		{
			if(CommonVariables.mastersTurn)
			{
				//that means I am the service provider
				//so I should read first
				
				String str = CommonReadWrite.read(CommonVariables.conn);
				readfield.setString(str);
				CommonVariables.mastersTurn = false;
				turnField.setString("Its your turn.");
			}
			else
			{
				if(cmd == sendCommnd)
				{
					CommonReadWrite.write(CommonVariables.conn, msgbox.getString().toString());
					CommonVariables.mastersTurn = true;
					turnField.setString("Your friend's turn");
				}
			}
		}
	}
	
	public void removeTicker()
	{
		form.setTicker(null);
	}

}
